"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var clrc_1 = require("clrc");
var get_random_string_1 = __importDefault(require("../../utils/get_random_string"));
function useLrc(lrc) {
    var lines = (0, react_1.useMemo)(function () {
        return (0, clrc_1.parse)(lrc).filter(function (line) { return line.type === clrc_1.LineType.LYRIC; })
            .map(function (l) { return ({
            id: (0, get_random_string_1.default)(),
            lineNumber: l.lineNumber,
            raw: l.raw,
            startMillisecond: l.startMillisecond,
            content: l.content,
        }); })
            .sort(function (a, b) { return a.startMillisecond - b.startMillisecond; });
    }, [lrc]);
    return lines;
}
exports.default = useLrc;
